/*
 * 
 * Copyright 2004 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the Sun Community Source
 * License v3.0/Jini Technology Specific Attachment v 1.0 (the
 * "License"). You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://wwws.sun.com/software/jini/licensing/SCSL3_JiniTSA1.html.
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Reference Code is Jini Technology Core Platform code, v2.0. The
 * Developer of the Reference Code is Sun Microsystems, Inc.
 * 
 * Contributor(s): Sun Microsystems, Inc.
 * 
 * The contents of this file comply with the Jini Technology Core
 * Platform Compatibility Kit, v2.0A.
 * 
 * Tester(s): Sun Microsystems, Inc.
 * 
 * Test Platform(s):
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Solaris(TM)SPARC/x86
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Linux (Intel x86)
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Windows (Intel Platform)
 * 
 */

package com.sun.jini.norm;

import java.io.IOException;
import java.io.InvalidObjectException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import net.jini.id.ReferentUuid;
import net.jini.id.ReferentUuids;
import net.jini.id.Uuid;

/**
 * Defines an abstract class that supplies basic referent UUID and
 * serialization behavior for Norm proxies.
 *
 * @author Sun Microsystems, Inc.
 * @since 2.0
 */
abstract class AbstractProxy implements ReferentUuid, Serializable {
    private static final long serialVersionUID = 1;

    /**
     * The server.
     *
     * @serial
     */
    final NormServer server;

    /**
     * The unique identifier for this proxy.
     *
     * @serial
     */
    final Uuid uuid;

    /** Creates an instance of this class. */
    AbstractProxy(NormServer server, Uuid uuid) {
	if (server == null) {
	    throw new NullPointerException("server cannot be null");
	} else if (uuid == null) {
	    throw new NullPointerException("uuid cannot be null");
	}
	this.server = server;
	this.uuid = uuid;
    }

    /** Require fields to be non-null. */
    private void readObjectNoData() throws InvalidObjectException {
	throw new InvalidObjectException(
	    "server and uuid must be non-null");
    }

    /** Require fields to be non-null. */
    private void readObject(ObjectInputStream in)
	throws IOException, ClassNotFoundException
    {
	in.defaultReadObject();
	if (server == null || uuid == null) {
	    throw new InvalidObjectException(
		"server and uuid must be non-null");
	}
    }

    /** Returns true if the object has the same UUID as this instance. */
    public boolean equals(Object object) {
	return ReferentUuids.compare(this, object);
    }

    /** Returns a hash code for this object. */
    public int hashCode() {
	return uuid.hashCode();
    }

    /* -- Implement ReferentUuid -- */

    /* inherit javadoc */
    public Uuid getReferentUuid() {
	return uuid;
    }
}
